#ifndef F_DEEP_SLEEP_H
#define F_DEEP_SLEEP_H

#include <Arduino.h>

namespace DeepSleep {
// https://en.cppreference.com/w/cpp/language/storage_duration
// When used in a declaration at namespace scope, it specifies internal linkage.
// internal linkage. The variable can be referred to from all scopes in the current translation unit. All variables
// which are declared at file scope have this linkage, including variables declared static at file scope.
static RTC_DATA_ATTR int bootCount = 0;

void deep_sleep(int time_to_sleep_in_seconds);
void print_wakeup_reason();

} // namespace DeepSleep

#endif
