#include <drs26.hpp>

/*
It happens for some reason that the sensor cant get reached every 2 time
Because the sensor use sdi12 protocoll we have to wait aproxemettly 1 secound between the commands
It is not known how lond the response takes so we use a while loop which can be a risk wehre the programm can get stuck
*/

void ForteDRS26 ::setup()
{
	drs26.begin(4);
}

out_data_drs26 ForteDRS26 ::readData()
{
	String sdiResponse = "";
	String measurement_command =
	    "1M!"; // The drs26 sensor uses the sdi12 protocoll , in the sdi12 protocoll is the measurement command is
	           // specified as 1M!=Sebsir measurement request at adress 1
	String data_command = "1D0!"; // and the followed data command 1D0! = Sensor data request at adress 1

	drs26.sendCommand(measurement_command);
	delay(1000);
	drs26.sendCommand(data_command);

	data = {-1, -1, -1};

	while (drs26.available()) {
		char next_character = drs26.read();
		if ((next_character != '\n') && (next_character != '\r')) {
			sdiResponse += next_character;
			delay(10); // 1 character ~ 7.5ms
		}
	}

	if (sdiResponse.length() > 1) {
		data.id = sdiResponse.substring(0, 8).toInt();
		data.circumferenceIncrement = sdiResponse.substring(9, 15).toFloat();
		data.temperature = sdiResponse.substring(16, 22).toFloat();
	}
	return data;
}

std::list<Message> ForteDRS26 ::buildMessages()
{
	std::list<Message> messages;
	MeasurementData circumferenceIncrementMeasurementData{
	    data.circumferenceIncrement, 0, {}, measurementTypeToString.at(MeasurementType::CIRCUMFERENCE_INCREMENT)};
	MeasurementData temperatureMeasurementData{
	    data.temperature, 0, {}, measurementTypeToString.at(MeasurementType::TEMPERATURE)};

	messages.emplace_back(Message{circumferenceIncrementMeasurementData, sensorInformation, 0});
	messages.emplace_back(Message{temperatureMeasurementData, sensorInformation, 0});

	ESP_LOGE(sensorInformation.getSensorName().c_str(), "test");
	return messages;
}
SensorInformation ForteDRS26::getSensorInformation() const
{
	return sensorInformation;
}
