//
// Created by zoe on 10/6/22.
//

#include "TestClientDataPackage.hpp"
#include "MeasurementData.hpp"
#include "Protocol.hpp"
#include <vector>

void test_export_to_json()
{
	auto dataPackage =
	    ClientDataPackage(MeasurementData{1.1, 0, {}, "TEMPERATURE"}, SensorInformation{"DRS26", Protocol::Analog}, 0);

	std::string json = dataPackage.getDataPackageAsMinifiedJsonString();
	// expected
	std::string expected =
	    R"({"sensorName":"DRS26","timestamp":0,"protocol":"ANALOG","value":1.1,"channel":0,"measurementType":"TEMPERATURE"})";

	TEST_ASSERT_EQUAL_STRING(expected.c_str(), json.c_str());
}
void test_export_to_json_no_analog()
{
	auto dataPackage =
	    ClientDataPackage(MeasurementData{1.1, {}, {}, "TEMPERATURE"}, SensorInformation{"DRS26_DIGITAL", Protocol::I2C}, 0);

	std::string json = dataPackage.getDataPackageAsMinifiedJsonString();
	// expected
	std::string expected =
	    R"({"sensorName":"DRS26_DIGITAL","timestamp":0,"protocol":"I2C","value":1.1,"measurementType":"TEMPERATURE"})";

	TEST_ASSERT_EQUAL_STRING(expected.c_str(), json.c_str());
}

void test_export_to_json_no_channel_no_address()
{
	auto dataPackage =
	    ClientDataPackage(MeasurementData{1.1,"TEMPERATURE"}, SensorInformation{"DRS26_DIGITAL", Protocol::I2C}, 0);

	std::string json = dataPackage.getDataPackageAsMinifiedJsonString();
	// expected
	std::string expected =
	    R"({"sensorName":"DRS26_DIGITAL","timestamp":0,"protocol":"I2C","value":1.1,"measurementType":"TEMPERATURE"})";

	TEST_ASSERT_EQUAL_STRING(expected.c_str(), json.c_str());
}