#include <f_deep_sleep.h>
/*
This code is under Public Domain License.
Author: Pranav Cherukupalli <cherukupallip@gmail.com>
*/

/* Data saved on the RTC memory will not be deletet while the deep sleep mode */
RTC_DATA_ATTR int bootCount = 0;
/* First we configure the wake up source We set our ESP32 to wake up every 5 seconds */
#define TIME_TO_SLEEP 5

void setup(){
  Serial.begin(115200);
  Serial.println("******************After weak up Programm starts in setup**********************");
  delay(1000); //Take some time to open up the Serial Monitor

}


void loop(){
  ++bootCount;
  Serial.println("Boot number: " + String(bootCount));
  //Print the wakeup reason for ESP32
  print_wakeup_reason();
  Serial.println("Setup ESP32 to sleep for every " + String(TIME_TO_SLEEP) + " Seconds");
  Serial.println("Going to sleep now");
  Serial.println();
  Serial.flush();
  //going to sleep
  deep_sleep(TIME_TO_SLEEP);
}
