#ifndef _ESPNOW
#define _ESPNOW

#include "Message.hpp"
#include "Time.hpp"
#include "ram_caching.hpp"
#include <ClientDataPackage.hpp>
#include <ESP32Time.h>
#include <Preferences.h>
#include <WiFi.h>
#include <esp_now.h>

typedef struct config {
	uint8_t host[6];
	long time_millis;
} config;

esp_err_t espnow_setup();
esp_err_t espnow_send_message(const Message& message);
bool is_host_defined();
void get_host_mac(uint8_t *destination);
void on_data_sent(const uint8_t *mac_addr, esp_now_send_status_t status);
void on_data_recv(const uint8_t *mac, const uint8_t *incomingData, int len);

#endif