#include "ina219.hpp"

void Forte_INA219 ::setup()
{
	Wire.begin(I2C_SDA, I2C_SCL);
	if (!ina219.begin()) {
		// Sensor init went wrong
		return;
	}
	// ina219.setMeasureMode(TRIGGERED);
}

out_data_ina219 Forte_INA219 ::read_data()
{
	ina219.getShuntVoltage_mV();
	if(ina219.success())
	{
	data.shuntVoltage_mV = ina219.getShuntVoltage_mV();
	data.busVoltage_V = ina219.getBusVoltage_V();
	data.current_mA = ina219.getCurrent_mA();
	data.power_mW = ina219.getPower_mW();
	data.loadVoltage_V = data.busVoltage_V + (data.shuntVoltage_mV / 1000);
	return data;
	}
	else
		throw NoDataAvailableException();
}

Message Forte_INA219::build_message()
{
	throw "Not yet implemented";
}