#ifndef _SCD30
#define _SCD30

#include "Message.hpp"
#include "NoDataAvailableException.hpp"
#include "forte_sensor.hpp"
#include "pinout.hpp"
#include <SparkFun_SCD30_Arduino_Library.h>
#include <Wire.h>

struct out_data_scd30 {
	float C02;
	float Temperature;
	float Humidity;
};

class Forte_SCD30 : public Forte_Sensor<out_data_scd30> {
  public:
	void setup();
	out_data_scd30 read_data();
	Message build_message();

  private:
	SCD30 airSensor;
	out_data_scd30 data;
};

#endif