#include "dr26.hpp"
#include "pinout.hpp"

Adafruit_ADS1115 ads;

void Forte_DR26 :: setup(){
   Wire.begin(I2C_SDA, I2C_SCL);
    ads.setGain(GAIN_ONE);
    ads.begin() ?  Serial.println("ADS initialized") : Serial.println("failed to initialize ADS");
    delay(100);
}

float* Forte_DR26 :: read_data(){
    for(int i=0; i<10; i++){
        int16_t adc = ads.readADC_SingleEnded(0);
        float volt = ads.computeVolts(adc);
        volts += volt;
    }
    volts /= 10;
    return &volts;
}
float volts = 0;
  // SETTING THE GAIN VALUE INCORRECTLY MAY DESTROY THE ADC!
  // The maximum output of the dendrometer is 2.5V, and so a gain of
  // one (max 4.096V) or two (max 2.048V) is optimal. Changing the gain
  // changes the accuracy of the sensor: higher gain gives a higher
  // precision but a smaller range.
  //                                                                
  // GAIN_TWOTHIRDS  // 2/3x gain +/- 6.144V  1 bit = 0.1875mV (default)
  // GAIN_ONE        // 1x gain   +/- 4.096V  1 bit = 0.125mV
  // GAIN_TWO        // 2x gain   +/- 2.048V  1 bit = 0.0625mV
  // GAIN_FOUR       // 4x gain   +/- 1.024V  1 bit = 0.03125mV
  // GAIN_EIGHT      // 8x gain   +/- 0.512V  1 bit = 0.015625mV
  // GAIN_SIXTEEN    // 16x gain  +/- 0.256V  1 bit = 0.0078125mV
void Forte_DR26 :: change_Gain(adsGain_t gain){
    ads.setGain(gain);
}