[//]: # ( @page examples_page Examples )
# Examples using the SDI-12 Library

[//]: # ( @brief Examples using the SDI-12 Library )

[//]: # ( Start GitHub Only )
- [Example A](@ref a_wild_card.ino):
  - Gets sensor information from a single attached sensor and prints it to the serial port
  - [GitHub](https://github.com/EnviroDIY/Arduino-SDI-12/tree/master/examples/a_wild_card)
- [Example B](@ref b_address_change.ino):
  - Allows you to change the address of your SDI-12 Sensor
  - [GitHub](https://github.com/EnviroDIY/Arduino-SDI-12/tree/master/examples/b_address_change)
- [Example C](@ref c_check_all_addresses.ino):
  - Checks all addresses for active sensors, and prints their status to the serial port
  - [GitHub](https://github.com/EnviroDIY/Arduino-SDI-12/tree/master/examples/c_check_all_addresses)
- [Example D](@ref d_simple_logger.ino):
  - Checks all addresses for active sensors, and logs data for each sensor every minute
  - [GitHub](https://github.com/EnviroDIY/Arduino-SDI-12/tree/master/examples/d_simple_logger)
- [Example E](@ref e_simple_parsing.ino):
  - Demonstrates the ability to parse integers and floats from the buffer.
  - [GitHub](https://github.com/EnviroDIY/Arduino-SDI-12/tree/master/examples/e_simple_parsing)
- [Example F](@ref f_basic_data_request.ino):
  - Issues a data request to a single specified sensor
  - [GitHub](https://github.com/EnviroDIY/Arduino-SDI-12/tree/master/examples/f_basic_data_request)
- [Example G](@ref g_terminal_window.ino):
  - Demonstrates using the Arduino as a command terminal for SDI-12 sensors.
  - [GitHub](https://github.com/EnviroDIY/Arduino-SDI-12/tree/master/examples/g_terminal_window)
- [Example H](@ref h_SDI-12_slave_implementation.ino):
  - Demonstrates using SDI-12 in slave mode
  - [GitHub](https://github.com/EnviroDIY/Arduino-SDI-12/tree/master/examples/h_SDI-12_slave_implementation)
- [Example I](@ref i_SDI-12_interface.ino):
  - Shows code for an Arduino-based USB dongle to translate between SDI-12 and a PC
  - [GitHub](https://github.com/EnviroDIY/Arduino-SDI-12/tree/master/examples/i_SDI-12_interface)
- [Example J](@ref j_external_pcint_library.ino):
  - Shows how to use an external PCInt library to call the interrupts for this library.
  - [GitHub](https://github.com/EnviroDIY/Arduino-SDI-12/tree/master/examples/j_external_pcint_library)
- [Example K](@ref k_concurrent_logger.ino):
  -  Shows how to request concurrent measurements
  - [GitHub](https://github.com/EnviroDIY/Arduino-SDI-12/tree/master/examples/k_concurrent_logger)

[//]: # ( End GitHub Only )

- [Example A](@ref a_wild_card.ino):
  - Gets sensor information from a single attached sensor and prints it to the serial port
  - [GitHub](https://github.com/EnviroDIY/Arduino-SDI-12/tree/master/examples/a_wild_card)
- [Example B](@ref b_address_change.ino):
  - Allows you to change the address of your SDI-12 Sensor
  - [GitHub](https://github.com/EnviroDIY/Arduino-SDI-12/tree/master/examples/b_address_change)
- [Example C](@ref c_check_all_addresses.ino):
  - Checks all addresses for active sensors, and prints their status to the serial port
  - [GitHub](https://github.com/EnviroDIY/Arduino-SDI-12/tree/master/examples/c_check_all_addresses)
- [Example D](@ref d_simple_logger.ino):
  - Checks all addresses for active sensors, and logs data for each sensor every minute
  - [GitHub](https://github.com/EnviroDIY/Arduino-SDI-12/tree/master/examples/d_simple_logger)
- [Example E](@ref e_simple_parsing.ino):
  - Demonstrates the ability to parse integers and floats from the buffer.
  - [GitHub](https://github.com/EnviroDIY/Arduino-SDI-12/tree/master/examples/e_simple_parsing)
- [Example F](@ref f_basic_data_request.ino):
  - Issues a data request to a single specified sensor
  - [GitHub](https://github.com/EnviroDIY/Arduino-SDI-12/tree/master/examples/f_basic_data_request)
- [Example G](@ref g_terminal_window.ino):
  - Demonstrates using the Arduino as a command terminal for SDI-12 sensors.
  - [GitHub](https://github.com/EnviroDIY/Arduino-SDI-12/tree/master/examples/g_terminal_window)
- [Example H](@ref h_SDI-12_slave_implementation.ino):
  - Demonstrates using SDI-12 in slave mode
  - [GitHub](https://github.com/EnviroDIY/Arduino-SDI-12/tree/master/examples/h_SDI-12_slave_implementation)
- [Example I](@ref i_SDI-12_interface.ino):
  - Shows code for an Arduino-based USB dongle to translate between SDI-12 and a PC
  - [GitHub](https://github.com/EnviroDIY/Arduino-SDI-12/tree/master/examples/i_SDI-12_interface)
- [Example J](@ref j_external_pcint_library.ino):
  - Shows how to use an external PCInt library to call the interrupts for this library.
  - [GitHub](https://github.com/EnviroDIY/Arduino-SDI-12/tree/master/examples/j_external_pcint_library)
- [Example K](@ref k_concurrent_logger.ino):
  -  Shows how to request concurrent measurements
  - [GitHub](https://github.com/EnviroDIY/Arduino-SDI-12/tree/master/examples/k_concurrent_logger)