from time import sleep
from machine import RTC


class RTCTime:
    # def __init__(
    #     self,
    #     main_ntp_server: str = "pool.ntp.org",
    #     backup_ntp_server: str = "time.nist.gov",
    #     update_interval_seconds: int = 3600,
    # ):
    #     self.rtc = RTC()
    #     self._setup_ntp(main_ntp_server, backup_ntp_server, update_interval_seconds)
    
    
    def __init__(self, datetime):
        self.rtc = RTC()
        self.rtc.init(datetime)

    def _setup_ntp(
        self, main_ntp_server: str, backup_ntp_server: str, update_interval_seconds: int
    ):
        print("Setting up NTP")
        self.rtc.ntp_sync(main_ntp_server, update_interval_seconds, backup_ntp_server)
        while not self.rtc.synced():
            print(self.rtc.synced())
            sleep(1)

    

    def get_time(self):
        return self.rtc.now()

    def is_synchronized(self):
        return self.rtc.synced()
