class DataTransferInterface:
    def connect(self):
        pass

    def disconnect(self):
        pass

    def send(self, data: str):
        pass


from network import WLAN
import lib.urequests as requests


class DataTransferWiFi(DataTransferInterface):
    def connect(self, ssid: str, password: str):
        self.wlan = WLAN(mode=WLAN.STA)
        self.wlan.connect(ssid, auth=(WLAN.WPA2, password))
        while not self.wlan.isconnected():
            pass
        print("Connected to Wifi")

    def disconnect(self):
        self.wlan.disconnect()

    def send(self, data: str):
        res = requests.post(
            "http://influxdb.qe-forte.uibk.ac.at/api/v2/write?org=QE&bucket=fipy-tests&precision=s",
            data=data,
            headers={
                "Authorization": "Token EML8-F4SfE6XiEAAcawwyA8cWzniCW7eYkCGnJ6hRnf1fyN4BrnxdBd3S56j4-MAZmi0FJu867YHvhflKeFmTw==",
                "Content-Type": "text/plain; charset=utf-8",
                "Accept": "application/json",
            },
        )
        print(res.status_code)
        print(res.reason)
